// usage: bass -m ffa.gb gb_rom_FFA_MSU1.asm


architecture lr35902

origin ($000146)
db $03 //add super gameboy support

origin ($00014b)
db $33 //add super gameboy support

origin ($00014d)
db $5d //add super gameboy support

origin ($00119d)
db $a0 //track change

origin ($0011A9)
db $a0 //track change

origin ($0011B5)
db $a0 //track change

origin ($003e7c) 
//origin ($003e87) //different for european mystic quest
db $a0 //track change



origin ($008efb)
db $a0 //track change

origin ($03c09e)
call $7ec0
ret

//Track change
origin ($03c02e)
call $7f60
nop
nop

origin ($03FEC0)

initTransfer:
// free space in bank 0f
//Transfer source needs to be executed in gb wram since the track numbers dynamically change
//dfc0 seem to be good 
		ld			a, $79
		ld			($df70),a //transfer command $79
//transfer snes destination address 7f0000		
		ld			a, $00
		ld			($df71),a 
		ld			a, $00
		ld			($df72),a 		
		ld			a, $7f
		ld			($df73),a
//number of bytes to transfer	(one byte)	 	
		ld			a, $01
		ld			($df74),a 	
//load theme number
		ld			a,($ffa0)
		ld			($df75),a

//transfer code			
		ld      hl, $df70
    ld      a,(hl)      // first byte is (command_id << $03) + (packet_count & $07)
    and     $07
    jr      z,done      // if packet_count is 0, transfer is complete
    ld      b,a         // b = packet_count
    ld      c,$00
start:
    push    bc
        ld      a,$00   // reset pulse low
        ld      (c),a
        ld      a,$30   // reset pulse high
        ld      (c),a
        ld      b,$10   // for (b = $10; b > 0; b--)    ; $10 bytes
    -;  ld      e,$08   // for (e = $08; e > 0; e--)    ; $08 bits
            ld      a,(hl+)
            ld      d,a         // d = *(ptr++)
        -;  bit     0,d         // check LSB of d
                ld      a,$10   // $10: transmit '1' bit
                jr      nz,+    // $20: transmit '0' bit
                    ld      a,$20
            +;  ld      (c),a
                ld      a,$30
                ld      (c),a
                rr      d       // d >>= 1
                dec     e
                jr      nz,-
            dec     b
            jr      nz,--
        ld      a,$20           // stop bit '0'
        ld      (c),a
        ld      a,$30
        ld      (c),a
        pop     bc              // b = packet_count
        dec     b               // packet_count--
        jr      z,+             // if packet_count is 0, this was the last packet
            push    bc
                ld      b,$05   // wait 60ms before transmitting another packet
                call    $7f40
            pop     bc
            jr      start       // start transmitting the next packet
+;  push    bc
        ld      b,$05           // wait 60ms for the transmission to complete
        call    $7f40
    pop     bc
    //ld      a,$01
done:
    //ld      ($2100),a
    //end transfer
		ld			a, $00
		ld			($ff90),a //mute
		ld			($ff93),a		
		or			a
		ret


origin ($03FF40)

-;  push    de
        ld      de,$0620    // for (de = $0620; de > 0; de--)
    -;  nop
            nop
            nop
            dec     de
            ld      a,d
            or      e
            jr      nz,-
    pop     de
    dec     b
    jr      nz,--
    ret

//for track change
origin ($03FF60)
ld a,($ffa0)
ld b,a
ld a,($df75)
ret

