; Patch by Conn
; apply on Super Game Boy (World) (Rev 2).sfc, EXPANDED TO 0.5 MB!



lorom

;nmi hook
org $00b515
JSL newTrack
JSL play
nop
nop

org $888000 ;expanded freespace
newTrack:
lda #$80  ; native code
sta $2115 ; native code
LDA $7f0000 ; here the track number is transferred to by SGB
CMP $0160 ; here we store the currently played theme to
BNE $01
RTL
checkBusy:
LDA $0161 ; check msu busy (is about to play)
CMP #$01
BEQ checkMSU
LDA $7f0000
STA $0162
RTL

checkMSU:
lda $002000
AND #$40
bne end
LDA $002000
AND #$08
BNE mute ;error bit set
STZ $0161 ; remove busy flag
LDA $0162
STA $0160 ; store track number
PHX
TAX
LDA $888200,x ;loop Table
STA $002007
STA $0163
LDA #$FF
STA $002006
PLX
end:
RTL
mute:
STZ $0161 ; remove busy flag
LDA $0162
STA $0160 ; store track number
LDA #$00
STA $002007
STA $002006
STA $0163
RTL


play:
LDA $0162
CMP $0160
BEQ endPlay
LDA $0161
CMP #$01
BEQ endPlay
LDA $0162
CMP #$00
BEQ zero
LDA $0163
CMP #$01
BNE playTrack
LDA $0162
CMP #$01
BEQ playTrack
CMP #$06
BEQ playTrack
LDA $002000
AND #$10
BNE endPlay
playTrack:
STZ $0163
LDA #$00
STA $002006
LDA $0162
STA $002004
STZ $002005
LDA #$01
STA $0161 ;set busy flag
endPlay:
rep #$20
LDA #$7000
RTL
zero:
LDA $0162
STA $0163´
STA $0160
STA $002007
STA $002006
BRA endPlay


; loop table 03:loop, 01 non-loop
org $888200
db $00,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 00-0f SMB1 and Lost Levels 
db $03,$01,$01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01,$01,$03,$03 ; themes 10-1f SMB1 and Lost Levels

